function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
% function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double   vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double   vector of endogenous variables in the order stored
%                                                     in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double   matrix of exogenous variables (in declaration order)
%                                                     for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double   vector of steady state values
%   params        [M_.param_nbr by 1]        double   vector of parameter values in declaration order
%   it_           scalar                     double   time period for exogenous variables for which
%                                                     to evaluate the model
%   T_flag        boolean                    boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   residual
%

if T_flag
    T = test.dynamic_resid_tt(T, y, x, params, steady_state, it_);
end
residual = zeros(54, 1);
lhs = exp(y(29));
rhs = T(1)^(-1)-params(25)*params(24)/(exp(y(80))-exp(y(26))*params(25));
residual(1) = lhs - rhs;
lhs = exp(y(28));
rhs = exp(y(29))*params(24)/exp(y(2));
residual(2) = lhs - rhs;
lhs = 1;
rhs = y(63)*exp(y(81))/exp(y(86));
residual(3) = lhs - rhs;
lhs = params(18)*exp(params(32)*y(27));
rhs = exp(y(29))*exp(y(30));
residual(4) = lhs - rhs;
lhs = exp(y(31));
rhs = (1+params(4)*exp(y(68))*exp(y(33)))/(exp(y(23))*exp(y(3)));
residual(5) = lhs - rhs;
lhs = exp(y(32));
rhs = (1+params(4)*exp(y(68))*exp(y(34)))/(exp(y(23))*exp(y(4)));
residual(6) = lhs - rhs;
lhs = T(2)*exp(y(35))+T(3)+exp(y(37));
rhs = exp(y(44))+exp(y(38));
residual(7) = lhs - rhs;
lhs = exp(y(38))*exp(y(45));
rhs = params(29)*(T(4)+(y(18)-y(19))*exp(y(7))+y(19)*exp(y(8)))+params(28);
residual(8) = lhs - rhs;
lhs = exp(y(41));
rhs = 1-params(29)+params(29)*exp(y(42))*exp(y(43));
residual(9) = lhs - rhs;
lhs = T(5)*(exp(y(82))-y(63));
rhs = exp(y(42))*exp(y(39))/(1+exp(y(39)));
residual(10) = lhs - rhs;
lhs = T(5)*(exp(y(83))-y(63));
rhs = exp(y(42))*params(27)*exp(y(39))/(1+exp(y(39)));
residual(11) = lhs - rhs;
lhs = T(5)*(y(62)-y(63));
rhs = (-y(40))/(1+exp(y(39)));
residual(12) = lhs - rhs;
lhs = exp(y(42))*exp(y(43));
rhs = T(7)-T(8);
residual(13) = lhs - rhs;
lhs = exp(y(43));
rhs = (T(2)*exp(y(35))+exp(y(36))*exp(y(34))*params(27))/exp(y(38));
residual(14) = lhs - rhs;
lhs = exp(y(46));
rhs = T(9);
residual(15) = lhs - rhs;
lhs = exp(y(47));
rhs = exp(y(50))*exp(y(52))+T(13);
residual(16) = lhs - rhs;
lhs = exp(y(48));
rhs = exp(y(52))+T(15);
residual(17) = lhs - rhs;
lhs = exp(y(52))*exp(y(49));
rhs = exp(y(51));
residual(18) = lhs - rhs;
lhs = exp(y(49));
rhs = (1-params(30))*exp(y(46)*(-y(70)))+T(18);
residual(19) = lhs - rhs;
lhs = 1;
rhs = (1-params(30))*exp(y(46)*(1-y(70)))+params(30)*exp(y(10)*params(31)*(1-y(70)))*exp(y(45)*(y(70)-1));
residual(20) = lhs - rhs;
lhs = exp(y(51));
rhs = exp(y(54))*exp(y(13)*params(5))*exp(y(27)*(1-params(5)));
residual(21) = lhs - rhs;
lhs = exp(y(53));
rhs = exp(y(56))+(1-params(6))*exp(y(13));
residual(22) = lhs - rhs;
lhs = T(19);
rhs = exp(y(57));
residual(23) = lhs - rhs;
lhs = T(20);
rhs = exp(y(30));
residual(24) = lhs - rhs;
residual(25) = y(58)*params(50)+(T(2)*(1+y(58))-T(22))*(1-params(50));
lhs = exp(y(56))*y(71)*exp(y(59));
rhs = T(23);
residual(26) = lhs - rhs;
lhs = exp(y(57));
rhs = exp(y(59))+exp(y(59))*y(58)*y(71);
residual(27) = lhs - rhs;
lhs = exp(y(56));
rhs = exp(y(60))*T(27);
residual(28) = lhs - rhs;
lhs = 1;
rhs = exp(y(59))*(T(27)-T(25)*params(15)*T(26))+T(31);
residual(29) = lhs - rhs;
lhs = y(61);
rhs = (1-params(34))*params(3)+params(34)*y(17)+(1-params(34))*(params(35)*(y(45)-log(params(2)))+params(36)*(y(52)-log(params(16))))+params(43)*x(it_, 6);
residual(30) = lhs - rhs;
residual(31) = (y(62)-1)*params(51)+(y(62)-y(61))*(1-params(51));
lhs = y(63);
rhs = y(62);
residual(32) = lhs - rhs;
lhs = T(2)*y(64)+T(32);
rhs = exp(y(37));
residual(33) = lhs - rhs;
lhs = y(64);
rhs = (1-params(37))*params(8)+params(37)*y(20)+params(44)*x(it_, 4);
residual(34) = lhs - rhs;
lhs = exp(y(65));
rhs = (1-params(38))*params(9)+params(38)*exp(y(21))+params(45)*x(it_, 5);
residual(35) = lhs - rhs;
lhs = exp(y(66))+params(10)/exp(y(45));
rhs = y(67)+T(33);
residual(36) = lhs - rhs;
lhs = y(66);
rhs = (1-params(39))*log(params(11))+params(39)*y(22)+params(47)*x(it_, 2);
residual(37) = lhs - rhs;
lhs = y(54);
rhs = (1-params(40))*log(params(12))+params(40)*y(14)+params(46)*x(it_, 1);
residual(38) = lhs - rhs;
lhs = y(42);
rhs = (1-params(34))*log(params(26))+params(34)*y(9)+x(it_, 3)*params(48);
residual(39) = lhs - rhs;
lhs = exp(y(55));
rhs = exp(y(35))+y(64);
residual(40) = lhs - rhs;
lhs = params(10);
rhs = exp(y(36))+exp(y(65));
residual(41) = lhs - rhs;
lhs = exp(y(52));
rhs = exp(y(66))+exp(y(26))+exp(y(60));
residual(42) = lhs - rhs;
lhs = y(68);
rhs = (1-params(42))*log(params(13))+y(23)*params(42)-params(49)*x(it_, 7);
residual(43) = lhs - rhs;
lhs = y(69);
rhs = log(T(1))-params(18)*exp(y(27))^(1+params(32))/(1+params(32))+params(24)*y(95);
residual(44) = lhs - rhs;
lhs = y(70);
rhs = (1-params(34))*params(14)+params(34)*y(24)+x(it_, 8);
residual(45) = lhs - rhs;
lhs = y(71);
rhs = (1-params(34))*params(7)*T(34)^(-params(33))+params(34)*y(25)+x(it_, 9);
residual(46) = lhs - rhs;
lhs = y(72);
rhs = y(31)-log(y(63));
residual(47) = lhs - rhs;
lhs = y(73);
rhs = y(32)-log(y(63));
residual(48) = lhs - rhs;
lhs = y(74);
rhs = y(52)-y(12);
residual(49) = lhs - rhs;
lhs = y(75);
rhs = y(26)-y(1);
residual(50) = lhs - rhs;
lhs = y(76);
rhs = y(60)-y(16);
residual(51) = lhs - rhs;
lhs = y(79);
rhs = y(65)-y(21);
residual(52) = lhs - rhs;
lhs = y(77);
rhs = y(35)-y(5);
residual(53) = lhs - rhs;
lhs = y(78);
rhs = y(36)-y(6);
residual(54) = lhs - rhs;

end
